diff --git a/openbsc/src/gsm_04_08.c b/openbsc/src/gsm_04_08.c
index 985f9e8..005d512 100644
--- a/openbsc/src/gsm_04_08.c
+++ b/openbsc/src/gsm_04_08.c
@@ -1876,7 +1876,7 @@ static int handle_abisip_signal(unsigned int subsys, unsigned int signal,
 		if (rc < 0)
 			goto out_err;
 		/* receive if whish is pending */
-		net = ts->trx->bts->network;
+		net = lchan->ts->trx->bts->network;
 		llist_for_each_entry(trans, &net->trans_list, entry) {
 			if (trans->lchan == lchan && trans->tch_recv) {
 				DEBUGP(DCC, "is pending tch_recv whish\n");
@@ -2009,7 +2009,7 @@ static int tch_recv(struct gsm_network *net, u_int32_t callref, int enable)
 			return -EINVAL;
 		}
 		/* in case, we don't have a socket yet */
-		if (!lchan->ts->abis_ip.rtp_socket) {
+		if (!lchan->abis_ip.rtp_socket) {
 			trans->tch_recv = enable;
 			DEBUGP(DCC, "queue tch_recv whish (%d)\n", enable);
 			return 0;
@@ -2020,10 +2020,10 @@ static int tch_recv(struct gsm_network *net, u_int32_t callref, int enable)
 			if (rc < 0)
 				return rc;
 			/* assign socket to application interface */
-			rtp_socket_upstream(lchan->ts->abis_ip.rtp_socket,
+			rtp_socket_upstream(lchan->abis_ip.rtp_socket,
 				net, callref);
 		} else
-			rtp_socket_upstream(lchan->ts->abis_ip.rtp_socket,
+			rtp_socket_upstream(lchan->abis_ip.rtp_socket,
 				net, 0);
 		break;
 	case GSM_BTS_TYPE_BS11:
@@ -3280,9 +3280,9 @@ int mncc_send(struct gsm_network *net, int msg_type, void *arg)
 		bts = trans->lchan->ts->trx->bts;
 		switch (bts->type) {
 		case GSM_BTS_TYPE_NANOBTS:
-			if (!trans->lchan->ts->abis_ip.rtp_socket)
+			if (!trans->lchan->abis_ip.rtp_socket)
 				return 0;
-			return rtp_send_frame(trans->lchan->ts->abis_ip.rtp_socket, arg);
+			return rtp_send_frame(trans->lchan->abis_ip.rtp_socket, arg);
 		case GSM_BTS_TYPE_BS11:
 			return trau_send_frame(trans->lchan, arg);
 		default:
